#include <cassert>

#include <vector>
using std::vector;

#include <stack>
using std::stack;

#include <iostream>
using std::cout;
using std::endl;
using std::ostream;

#include "saw.hpp"

const size_t N = 14;
typedef saw<step2d> saw2d;
stack<saw2d> S;
vector<double> r2(N);
vector<size_t> num(N);

int main()
{
	for (size_t i = 0; i < N; ++i)
	{
		r2[i] = 0.0;
		num[i] = 0.0;
	}

	S.push(saw2d('n'));
	num[0] = 1;
	r2[0] = 1.0;
	while (!S.empty())
	{
		saw2d walk = S.top();
		S.pop();
		const size_t l = walk.length();
		if (l < N)
		{
			const char dir[] = "nswe";
			const char opp[] = "snew";
			for (size_t i = 0; i < 4; ++i)
				if (walk.last_direction() != opp[i] and walk.is_allowed(dir[i]))
				{
					S.push(walk + dir[i]);
					++num[l];
					const double x = S.top().last_step().x;
					const double y = S.top().last_step().y;
					r2[l] += x*x+y*y;
				}
		}
	}
	
	for (size_t l = 0; l < N; ++l)
		cout << l+1 << "\t" << 4*num[l] << "\t" << r2[l]/num[l] << endl;
	return 0;
}

