#include <cassert>

#include <vector>
using std::vector;

#include <queue>
using std::queue;

#include <iostream>
using std::cerr;
using std::cout;
using std::endl;
using std::ostream;

#include "saw.hpp"

const size_t N = 10;
typedef saw<step3d> saw3d;
queue<saw3d> Q;
vector<double> r2(N);
vector<size_t> num(N);

int main()
{
	for (size_t i = 0; i < N; ++i)
	{
		r2[i] = 0.0;
		num[i] = 0.0;
	}

	Q.push(saw3d('n'));
	num[0] = 1;
	r2[0] = 1.0;
	size_t n = Q.front().length();
	while (!Q.empty())
	{
		saw3d walk = Q.front();
		Q.pop();
		const size_t l = walk.length();
		if (l < N)
		{
			const char dir[] = "nsweud";
			const char opp[] = "snewdu";
			for (size_t i = 0; i < 6; ++i)
				if (walk.last_direction() != opp[i] and walk.is_allowed(dir[i]))
				{
					Q.push(walk + dir[i]);
					const size_t nn = Q.front().length();
					if (nn > n)
					{
						cerr << "Length " << n << " enumerated" << endl;
						n = nn;
					}
					++num[l];
					const double x = Q.back().last_step().x;
					const double y = Q.back().last_step().y;
					const double z = Q.back().last_step().z;
					r2[l] += x*x+y*y+z*z;
				}
		}
	}
	
	for (size_t l = 0; l < N; ++l)
		cout << l+1 << "\t" << 6*num[l] << "\t" << r2[l]/num[l] << endl;
	return 0;
}

